module GithubMembers
  class Member
    DEFAULT_FIELDS = [:github, :fullname, :avatar, :updated].freeze

    def define_class(*fields)
      Struct.new(*DEFAULT_FIELDS, *fields, keyword_init: true) do
        def github_url
          "https://github.com/#{github}"
        end

        def additional_fields
          members - DEFAULT_FIELDS
        end

        def to_h
          super.to_h.transform_keys(&:to_s).reject { |k, _| k == "updated" }
        end
      end
    end
  end
end
